// BonTuner.cpp: CBonTuner NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include <winsock2.h>
#include <Windows.h>
#include <SetupApi.h>
#include <Malloc.h>
#include <InitGuid.h>
#include <Math.h>
#include "Resource.h"
#include "BonTuner.h"
#include <stdio.h>

#pragma comment(lib, "SetupApi.lib")
#pragma comment(lib, "ws2_32.lib")

#define UDP_PORT_NO			1234

//////////////////////////////////////////////////////////////////////
// 萔`
//////////////////////////////////////////////////////////////////////

// hConhCfbNX
#define DEVICE_CONTROL		0x00			// `[iRg[
#define DEVICE_STREAM		0x01			// TSXg[

// I/ORg[R[h
#define IOCODE_CONTROL		0x00220020		// `[iRg[
#define IOCODE_TSDATA		0x0022004B		// TSXg[

// MTCY
//#define TSDATASIZE			48128			// TSf[^̃TCY
#define TSDATASIZE			65536			// TSf[^̃TCY

// FIFOobt@ݒ
#define ASYNCBUFFTIME		2											// obt@ = 2b
#define ASYNCBUFFSIZE		( 0x200000 / TSDATASIZE * ASYNCBUFFTIME )	// 16MbpsƂ

#define REQRESERVNUM		16				// 񓯊NGXg\
#define REQPOLLINGWAIT		10				// 񓯊NGXg|[OԊu(ms)

// 񓯊NGXg
#define IORS_IDLE			0x00			// NGXg
#define IORS_BUSY			0x01			// NGXgM	
#define IORS_RECV			0x02			// MAXgA҂

/* BonTuner_meru.cppւ̈ڐAɔp~ byMeru(2008/01/22)
// hCoMf[^
static const BYTE ChSelReq1[] = {0x40, 0x03, 0x00, 0x30, 0xFE, 0x00, 0x05, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0xC0, 0x00, 0x00, 0xB2, 0x08};
static const BYTE ChSelReq2[] = {0x40, 0x03, 0x00, 0x30, 0xFE, 0x00, 0x05, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0xC0, 0x00, 0x00, 0x9A, 0x50};
static const BYTE GetTsReq[]  = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
static const BYTE GetLevReq[] = {0xC0, 0x02, 0x00, 0x30, 0x89, 0x00, 0x25, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x31, 0x3A, 0x4B, 0x03, 0x00, 0x34, 0x08, 0x78, 0x00, 0x00, 0x40, 0x7F, 0xDC, 0xAC, 0x0F, 0x00, 0x00, 0x00, 0x01, 0xE3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0xF4};
*/
// hCoCX^XGUID
//DEFINE_GUID( GUID_FRIIO_DRIVER,	0x5a56d255L, 0xe23a, 0x4b4d, 0x8c, 0x78, 0xc2, 0x65, 0x93, 0x0b, 0x6c, 0x68 );
DEFINE_GUID( GUID_FRIIO_DRIVER,	0xae18aa60, 0x7f6a, 0x11d4, 0x97, 0xdd, 0x0, 0x1, 0x2, 0x29, 0xb9, 0x59 );

//////////////////////////////////////////////////////////////////////
// CX^X\bh
//////////////////////////////////////////////////////////////////////

#pragma warning( disable : 4273 )

extern "C" __declspec(dllexport) IBonDriver * CreateBonDriver()
{
	// X^X(̏ꍇ̓CX^X̃|C^Ԃ)
	return (CBonTuner::m_pThis)? CBonTuner::m_pThis : ((IBonDriver *) new CBonTuner);
}

#pragma warning( default : 4273 )


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

// ÓIo
CBonTuner * CBonTuner::m_pThis = NULL;
HINSTANCE CBonTuner::m_hModule = NULL;

CBonTuner::CBonTuner()
{
	m_pThis = this;

	// o
	m_sock = INVALID_SOCKET;

	// obt@|C^
	m_pIoReqBuff = NULL;
	m_pIoPushReq = NULL;
	m_pIoPopReq = NULL;

	// Xbhnh
	m_hPushIoThread = NULL;
	m_hPopIoThread = NULL;

	// NeBJZNV
	::InitializeCriticalSection(&m_CriticalSection);

	// Cxg
	m_hOnStreamEvent = NULL;

	// Winsock
	WSADATA stWsa;
	WSAStartup(MAKEWORD(2,0),&stWsa);
}

CBonTuner::~CBonTuner()
{
	// JĂꍇ͕
	CloseTuner();

	// NeBJZNV폜
	::DeleteCriticalSection(&m_CriticalSection);

	// WinsockI
	WSACleanup();

	m_pThis = NULL;
}

const BOOL CBonTuner::OpenTuner()
{
	// UN[Y
	CloseTuner();

	// obt@m
	if(!(m_pIoReqBuff = AllocIoReqBuff(ASYNCBUFFSIZE))){
		return FALSE;
		}

	// obt@ʒu
	m_pIoPushReq = m_pIoReqBuff;
	m_pIoPopReq = m_pIoReqBuff;
	m_pIoGetReq = m_pIoReqBuff;
	m_dwBusyReqNum = 0;
	m_dwReadyReqNum = 0;

	// hCoI[v
	m_sock = socket(AF_INET,SOCK_DGRAM,0);
	if(m_sock==INVALID_SOCKET){
		CloseTuner();
		return FALSE;
		}

	// Bind
	struct sockaddr_in stAddr;
	stAddr.sin_family = AF_INET;
	stAddr.sin_port = htons(UDP_PORT_NO);
	stAddr.sin_addr.S_un.S_addr = INADDR_ANY;
	if(SOCKET_ERROR==bind(m_sock, (struct sockaddr *)&stAddr, sizeof(stAddr))){
		CloseTuner();
		return FALSE;
		}

	// Cxg쐬
	if(!(m_hOnStreamEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL))){
		CloseTuner();
		return FALSE;
		}

	// XbhN
	DWORD dwPushIoThreadID = 0, dwPopIoThreadID = 0;
	m_hPushIoThread = ::CreateThread(NULL, 0, CBonTuner::PushIoThread, this, CREATE_SUSPENDED, &dwPopIoThreadID);
	m_hPopIoThread = ::CreateThread(NULL, 0, CBonTuner::PopIoThread, this, CREATE_SUSPENDED, &dwPushIoThreadID);

	if(!m_hPushIoThread || !m_hPopIoThread){
		if(m_hPushIoThread){
			::TerminateThread(m_hPushIoThread, 0);
			::CloseHandle(m_hPushIoThread);
			m_hPushIoThread = NULL;
			}

		if(m_hPopIoThread){
			::TerminateThread(m_hPopIoThread, 0);
			::CloseHandle(m_hPopIoThread);
			m_hPopIoThread = NULL;
			}

		CloseTuner();
		return FALSE;
		}

	// XbhJn
	m_bLoopIoThread = TRUE;
	if(::ResumeThread(m_hPushIoThread) == 0xFFFFFFFF || ::ResumeThread(m_hPopIoThread) == 0xFFFFFFFF){
		CloseTuner();
		return FALSE;
		}

	return TRUE;
}

void CBonTuner::CloseTuner()
{
	// XbhIvZbg
	m_bLoopIoThread = FALSE;

	// CxgJ
	::CloseHandle(m_hOnStreamEvent);
	m_hOnStreamEvent = NULL;	

	// XbhI
	if(m_hPushIoThread){
		if(::WaitForSingleObject(m_hPushIoThread, 1000) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPushIoThread, 0);
			::OutputDebugString("::TerminateThread(m_hPushIoThread)\n");
			}		

		::CloseHandle(m_hPushIoThread);
		m_hPushIoThread = NULL;
		}

	if(m_hPopIoThread){
		if(::WaitForSingleObject(m_hPopIoThread, 1000) != WAIT_OBJECT_0){
			// XbhI
			::TerminateThread(m_hPopIoThread, 0);
			::OutputDebugString("::TerminateThread(m_hPopIoThread)\n");
			}		

		::CloseHandle(m_hPopIoThread);
		m_hPopIoThread = NULL;
		}


	// obt@J
	FreeIoReqBuff(m_pIoReqBuff);
	m_pIoReqBuff = NULL;
	m_pIoPushReq = NULL;
	m_pIoPopReq = NULL;
	m_pIoGetReq = NULL;

	// IŒf[^M
//	if(m_hDevice[DEVICE_CONTROL] != INVALID_HANDLE_VALUE){
//		SendFixedRequest(IDR_IOL_ENDSEQ);
//		}
//	UsbTerminate(DEVICE_CONTROL,DEVICE_STREAM);

	// hCoN[Y
	if(m_sock != INVALID_SOCKET){
		closesocket(m_sock);
		m_sock = INVALID_SOCKET;
		}
}

const DWORD CBonTuner::WaitTsStream(const DWORD dwTimeOut)
{
	// I`FbN
	if(!m_hOnStreamEvent || !m_bLoopIoThread)return WAIT_ABANDONED;

	// CxgVOiԂɂȂ̂҂
	const DWORD dwRet = ::WaitForSingleObject(m_hOnStreamEvent, (dwTimeOut)? dwTimeOut : INFINITE);

	switch(dwRet){
		case WAIT_ABANDONED :
			// `[iꂽ
			return WAIT_ABANDONED;

		case WAIT_OBJECT_0 :
		case WAIT_TIMEOUT :
			// Xg[擾\ or `[iꂽ
			return (m_bLoopIoThread)? dwRet : WAIT_ABANDONED;

		case WAIT_FAILED :
		default:
			// O
			return WAIT_FAILED;
		}
}

const DWORD CBonTuner::GetReadyCount()
{
	// o\TSf[^擾
	return m_dwReadyReqNum;
}

const BOOL CBonTuner::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	BYTE *pSrc = NULL;

	// TSf[^obt@o
	if(GetTsStream(&pSrc, pdwSize, pdwRemain)){
		if(*pdwSize){
			::CopyMemory(pDst, pSrc, *pdwSize);
			}
		
		return TRUE;
		}
	
	return FALSE;
}

const BOOL CBonTuner::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	if(!m_pIoGetReq)return FALSE;

	// TSf[^obt@o
	if(m_dwReadyReqNum){
		if(m_pIoGetReq->dwState == IORS_RECV){

			// f[^Rs[
			*pdwSize = m_pIoGetReq->dwRxdSize;
			*ppDst = m_pIoGetReq->RxdBuff;

			// obt@ʒui߂
			::EnterCriticalSection(&m_CriticalSection);
			m_pIoGetReq = m_pIoGetReq->pNext;
			m_dwReadyReqNum--;
			*pdwRemain = m_dwReadyReqNum;
			::LeaveCriticalSection(&m_CriticalSection);

			return TRUE;
			}
		else{
			// O
			return FALSE;
			}
		}
	else{
		// o\ȃf[^Ȃ
		*pdwSize = 0;
		*pdwRemain = 0;

		return TRUE;
		}
}

void CBonTuner::PurgeTsStream()
{
	// obt@o\f[^p[W

	::EnterCriticalSection(&m_CriticalSection);
	m_pIoGetReq = m_pIoPopReq;
	m_dwReadyReqNum = 0;
	::LeaveCriticalSection(&m_CriticalSection);
}

void CBonTuner::Release()
{
	// CX^XJ
	delete this;
}

const BOOL CBonTuner::GetDriverPath(GUID *pGuid, LPSTR lpszPath)
{
	// GUIDfoCX̃pX擾

	// foCXZbg̃nh擾
	HDEVINFO hDevInfo = SetupDiGetClassDevs(pGuid, 0, NULL, DIGCF_PRESENT | DIGCF_INTERFACEDEVICE);
	if(hDevInfo == INVALID_HANDLE_VALUE)return FALSE;

	// foCXC^tF[X
	SP_DEVICE_INTERFACE_DATA DeviceInterfaceData;
	DeviceInterfaceData.cbSize = sizeof(DeviceInterfaceData);
	if(!SetupDiEnumDeviceInterfaces( hDevInfo, NULL, pGuid, 0, &DeviceInterfaceData)){
		SetupDiDestroyDeviceInfoList(hDevInfo);
		return FALSE;
		}

	// foCXC^tF[X̏ڍׂi[̂ɕKvȃobt@TCY擾
	DWORD dwBuffLen = 0;
	SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, NULL, 0, &dwBuffLen, NULL);

	// obt@m
	dwBuffLen += sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA) + 1;
	SP_DEVICE_INTERFACE_DETAIL_DATA *pDeviceInterfaceDetailData = (SP_DEVICE_INTERFACE_DETAIL_DATA *)_alloca(dwBuffLen);
	pDeviceInterfaceDetailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

	// foCX̃pX擾
	if(!SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, pDeviceInterfaceDetailData, dwBuffLen, NULL, NULL)){
		SetupDiDestroyDeviceInfoList(hDevInfo);
		return FALSE;
		}

	// foCXZbg̃nhJ
	SetupDiDestroyDeviceInfoList(hDevInfo);

	// foCX̃pXRs[
	lstrcpy(lpszPath, pDeviceInterfaceDetailData->DevicePath);

	return TRUE;
}

const int CBonTuner::SendIoRequest(const BYTE bDevice, const DWORD dwIoCode, BYTE *pTxdData, const DWORD dwTxdSize, BYTE *pRxdData, const DWORD dwRxdSize)
{
	// I[v`FbN
	if(m_sock == INVALID_SOCKET)return -1;

	// Mf[^Rs[
	::CopyMemory(m_TxdBuff, pTxdData, dwTxdSize);

	// f[^M
	DWORD dwReturned = 0;
	dwReturned = send(m_sock,(const char*)m_TxdBuff,dwTxdSize,0);
	
	return (int)dwReturned;
}

const BOOL CBonTuner::SendFixedRequest(const UINT nID)
{
	// \[Xnh擾
	HRSRC hRsrc = ::FindResource(m_hModule, MAKEINTRESOURCE(nID), "BINARY");
	if(!hRsrc)return FALSE;

	// \[X[h
	HGLOBAL hGlobal = ::LoadResource(m_hModule, hRsrc);
	if(!hGlobal)return FALSE;

	// |C^擾
	BYTE *pFixedBuff = (BYTE *)::LockResource(hGlobal);
	if(!pFixedBuff)return FALSE;

	// \[XTCY擾
	const DWORD dwIoReqSize = ::SizeofResource(m_hModule, hRsrc);

	// \[Xf[^𑗐M
	DWORD dwXmited = 0;
	FixedIoReqHead *pIoReqHead;

	while(dwXmited < dwIoReqSize){
		// Rg[擾
		pIoReqHead = (FixedIoReqHead *)pFixedBuff;
		pFixedBuff += sizeof(FixedIoReqHead);

		// f[^M
		if(SendIoRequest(pIoReqHead->bDevice, pIoReqHead->dwIoCode, pFixedBuff, pIoReqHead->wTxdSize, m_RxdBuff, pIoReqHead->wRxdSize) == -1)return FALSE;
		pFixedBuff += pIoReqHead->wTxdSize;
		
		// MσTCYXV
		dwXmited += (sizeof(FixedIoReqHead) + pIoReqHead->wTxdSize);
		}

	return TRUE;
}

CBonTuner::AsyncIoReq * CBonTuner::AllocIoReqBuff(const DWORD dwBuffNum)
{
	DWORD dwIndex;
	if(dwBuffNum < 2)return NULL;

	// mۂ
	AsyncIoReq *pNewBuff = new AsyncIoReq [dwBuffNum];
	if(!pNewBuff)return NULL;

	// [NA
	::ZeroMemory(pNewBuff, sizeof(AsyncIoReq) * dwBuffNum);

	// N\z
	for(dwIndex = 0 ; dwIndex < ( dwBuffNum - 1 ) ; dwIndex++){
		pNewBuff[dwIndex].pNext= &pNewBuff[dwIndex + 1];
		}

	pNewBuff[dwIndex].pNext = &pNewBuff[0];

	return pNewBuff;
}

void CBonTuner::FreeIoReqBuff(CBonTuner::AsyncIoReq *pBuff)
{
	if(!pBuff)return;

	// obt@J
	delete [] pBuff;
}

DWORD WINAPI CBonTuner::PushIoThread(LPVOID pParam)
{
	CBonTuner *pThis = (CBonTuner *)pParam;

	DWORD dwLastTime = ::GetTickCount();

//	::OutputDebugString("CBonTuner::PushIoThread() Start!\n");

	// ǉ byMeru(2008/01/22)
	BYTE TxdData[256];

	// hCoTSf[^NGXg𔭍s
	while(pThis->m_bLoopIoThread){

		// NGXg҂K薢Ȃǉ
		if(pThis->m_dwBusyReqNum < REQRESERVNUM){

			// hCoTSf[^NGXg𔭍s(UDPƔŝ͂Ȃ)
			// if(!pThis->PushIoRequest(DEVICE_STREAM, IOCODE_TSDATA, (BYTE *)GetTsReq, sizeof(GetTsReq), TSDATASIZE)){			
			if(!pThis->PushIoRequest(DEVICE_STREAM, IOCTL_ADAPT_SEND_NON_EP0_DIRECT, TxdData, 0, TSDATASIZE)){
				// G[
				break;
				}

			continue;
			}

		// NGXg҂t̏ꍇ̓EFCg
		::Sleep(REQPOLLINGWAIT);
		}

//	::OutputDebugString("CBonTuner::PushIoThread() End!\n");

	return 0;
}

DWORD WINAPI CBonTuner::PopIoThread(LPVOID pParam)
{
	CBonTuner *pThis = (CBonTuner *)pParam;

//	::OutputDebugString("CBonTuner::PopIoThread() Start!\n");

	// σNGXg|[OăNGXg
	while(pThis->m_bLoopIoThread){

		// σf[^΃NGXg
		if(pThis->m_dwBusyReqNum){
			
			// NGXg
			if(!pThis->PopIoRequest()){
				// G[
				//break;
				}
			}
		}

//	::OutputDebugString("CBonTuner::PopIoThread() End!\n");

	return 0;
}

const BOOL CBonTuner::PushIoRequest(const BYTE bDevice, const DWORD dwIoCode, BYTE *pTxdData, const DWORD dwTxdSize, const DWORD dwRxdSize)
{
	// hCoɔ񓯊NGXg𔭍s

	// I[v`FbN
	if(m_sock == INVALID_SOCKET)return FALSE;

	// NGXgZbg
	m_pIoPushReq->dwDevice = (DWORD)bDevice;
	m_pIoPushReq->dwIoCode = dwIoCode;
	m_pIoPushReq->dwTxdSize = dwTxdSize;
	m_pIoPushReq->dwRxdSize = 0;
	if(dwTxdSize)::CopyMemory(m_pIoPushReq->TxdBuff, pTxdData, dwTxdSize);

	// Cxgݒ
	::ZeroMemory(&m_pIoPushReq->OverLapped, sizeof(OVERLAPPED));
	if(!(m_pIoPushReq->OverLapped.hEvent = WSACreateEvent()))return FALSE;

	// UDPMȂ҂I
	DWORD Flags=0;
	WSABUF wsaBuf;
	wsaBuf.buf = (char*)m_pIoPushReq->RxdBuff;
	wsaBuf.len = sizeof(m_pIoPushReq->RxdBuff);
	if(SOCKET_ERROR==WSARecv(m_sock,&wsaBuf,1,&m_pIoPushReq->dwRxdSize,&Flags,(LPWSAOVERLAPPED)&m_pIoPushReq->OverLapped,NULL)){
		int sock_err = WSAGetLastError();
		if(sock_err != ERROR_IO_PENDING){
			return FALSE;
			}
		}

	m_pIoPushReq->dwState = IORS_BUSY;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPushReq = m_pIoPushReq->pNext;
	m_dwBusyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);

	return TRUE;
}

const BOOL CBonTuner::PopIoRequest(void)
{
	// 񓯊NGXg
	
	// I[v`FbN
	if(m_sock == INVALID_SOCKET)return FALSE;
	
	// ԃ`FbN
	if(m_pIoPopReq->dwState != IORS_BUSY){
		// O
		return TRUE;
		}

	// NGXg擾
	DWORD Flags=0;
	const BOOL bRet = ::WSAGetOverlappedResult(m_sock, &m_pIoPopReq->OverLapped, &m_pIoPopReq->dwRxdSize, FALSE,&Flags);

	// G[`FbN
	if(!bRet){
		int sock_err = WSAGetLastError();
		if(sock_err == ERROR_IO_INCOMPLETE){
			// 
			::Sleep(REQPOLLINGWAIT);
			return TRUE;
			}
		}

	// Cxg폜
	::CloseHandle(m_pIoPopReq->OverLapped.hEvent);

	m_pIoPopReq->dwState = IORS_RECV;

	// obt@ԍXV
	::EnterCriticalSection(&m_CriticalSection);
	m_pIoPopReq = m_pIoPopReq->pNext;
	m_dwBusyReqNum--;
	m_dwReadyReqNum++;
	::LeaveCriticalSection(&m_CriticalSection);

	// CxgZbg
	::SetEvent(m_hOnStreamEvent);

	return TRUE;
}

